--- linuxppc_2_4_devel/drivers/video/matrox/matroxfb_base.h	2003-02-01 13:34:38.000000000 +0000
+++ linuxppc_2_4_devel-local/drivers/video/matrox/matroxfb_base.h	2003-02-02 12:21:00.000000000 +0000
@@ -108,12 +108,11 @@
 #endif
 #endif
 
-#if defined(__alpha__) || defined(__mc68000__)
+#if defined(__alpha__) || defined(__mc68000__) || defined(__powerpc__)
 #define READx_WORKS
 #define MEMCPYTOIO_WORKS
 #else
 #define READx_FAILS
-/* recheck __ppc__, maybe that __ppc__ needs MEMCPYTOIO_WRITEL */
 /* I benchmarked PII/350MHz with G200... MEMCPY, MEMCPYTOIO and WRITEL are on same speed ( <2% diff) */
 /* so that means that G200 speed (or AGP speed?) is our limit... I do not have benchmark to test, how */
 /* much of PCI bandwidth is used during transfers... */
@@ -841,7 +840,12 @@
 #define M_OPMODE_32BPP	(M_OPMODE_DMA_LE | M_OPMODE_DIR_LE | M_OPMODE_DMA_BLIT)
 #else
 #ifdef __BIG_ENDIAN
+#if defined(__powerpc__)
+/* we use little endian register access on ppc, but big endian framebuffer */
+#define MX_OPTION_BSWAP		0x00000000
+#else
 #define MX_OPTION_BSWAP		0x80000000
+#endif
 
 #define M_OPMODE_4BPP	(M_OPMODE_DMA_LE | M_OPMODE_DIR_LE | M_OPMODE_DMA_BLIT)	/* TODO */
 #define M_OPMODE_8BPP	(M_OPMODE_DMA_BE_8BPP  | M_OPMODE_DIR_BE_8BPP  | M_OPMODE_DMA_BLIT)
